# Getting Started

## Installation
To install the datapack, first download the latest release from [Modrinth](https://modrinth.com/datapack/code-of-copper){target=_blank}.  
You will also need [Moxlib](https://modrinth.com/datapack/moxlib){target=_blank}, and if you want [Regular Expression](data_types.md#regex) support, [Regex](https://modrinth.com/datapack/regex){target=_blank}.

Put these in the `datapacks` folder of your world. For more information, see the [Minecraft wiki](https://minecraft.wiki/Tutorials/Installing_a_data_pack){target=_blank}.

When you install the datapack, you must leave and rejoin the world (or restart the server) for all effects to properly take place.

## Obtaining a Copper Golem
Golems are found in airships, which generate naturally throughout your world when you have the datapack installed. Make sure to keep your render distance up, they spawn around 200 blocks in the air!

Looking for shadows on the ground is a great way to locate airships.  
Each airship contains one copper golem, alongside three example programs to help you get started with GolemScript.

If you would like to follow along with the datapack and learn the language as you go, stop reading here. 

## Getting started with GolemScript
GolemScript is written in Minecraft books, which are applied to the golem to give it a program.  
There are many built-in [functions](stdlib.md), [keywords](keywords.md) and [operators](operators.md). These are all documented throughout this site.

For the basic GolemScript syntax, see [syntax](syntax.md).  
For the various data-types and values you will use, see [data types](data_types.md).  
And for some example programs utilising these features, see [examples](examples.md).

## Extending GolemScript
GolemScript has many built-in functions, to aid you in programming with it. If there are missing functions, you can define custom functions within GolemScript.  
However, not all behaviour is possible to implement inside GolemScript, and so sometimes you need to write it in native mcfunction.  
Luckily, GolemScript has you covered! See [plugins](plugins.md) for information on creating your own built-in functions.